/* vc_cpp */

/* 
 * Problem  : 	DIST
 * Contest  : 	UOI-2006 (Dnepropetrovsk)
 * Type     : 	Solution
 * Date     : 	April 1, 2006
 * Author   : 	Vladimir Tkachuk
 * Language :	C++
 * Compiler :	VC 6.0
 * Algorithm:	Bad precision solution (fastest algorithm)
 */

#include <cmath>
#include <utility>
#include <vector>
#include <fstream>
#include <iomanip>
#include <string>
#include <iostream>
#include <algorithm>
#include <sstream>
using namespace std;
typedef pair<int,int> point;
#define sqr(a) ((a)*(a))
vector<point> P;
int N;
inline int operator &(point a, point b){
	return a.first*b.second-a.second*b.first;
}
inline int operator *(point a, point b){
	return a.first*b.first+a.second*b.second;
}
inline point operator - (point a, point b){
	return make_pair(a.first-b.first,a.second-b.second);
}
inline void gen_line(point A, point B, double &a, double &b, double &c){
	a = A.second-B.second;
	b = B.first-A.first;
	c = -a*A.first-b*A.second;
	double dd = sqrt(sqr(a)+sqr(b));
	a/=dd;
	b/=dd;
	c/=dd;
}
class PointComparer{
private:
	point t;
public:
	PointComparer(point t){
		this->t = t;
	}
	bool operator () (point& a, point& b){
		int s = (a-t)&(b-t);
		return (s<0||(s==0&&((a-t)*(b-a)<0)));
	}
};
void ReadData(string filename){
	ifstream in(filename.c_str());
	in>>N;
	P.clear();
	for (int i =0; i<N; ++i){
		int x,y;
		in>>x>>y;
		P.push_back(make_pair(x,y));
	}
	in.close();
}
void WriteAnswer(double ans, string filename){
	ofstream out(filename.c_str());
	out<<setprecision(5)<<ans<<endl;
	out.close();
}
vector<point> cp;
void BuildConvexHull(){
	point m = *min_element(P.begin(),P.end());
	sort(P.begin(),P.end(),PointComparer(m));
	cp.clear();
	int M =0;
	for(int i =0; i<N; ++i){
		while (cp.size()>1&&((cp[M-1]-cp[M-2])&(P[i]-cp[M-2]))>=0){
			--M;
			cp.pop_back();
		}
		cp.push_back(P[i]);
		++M;
	}
}

double GetAnswer(){ //Correct with O(N^2logN)
	double ans = 0;
	BuildConvexHull();
	vector<point> G;
	G.reserve(N);
	for (int i = 0; i<N; ++i){
		G.resize(0);
		int j;
		for (j = 0; j<N; ++j){
			if (P[j].first>P[i].first||(P[j].first==P[i].first&&P[j].second>P[i].second)){
				G.push_back(P[j]);
			}
		}
		if (G.empty()) continue;
		sort(G.begin(),G.end(),PointComparer(P[i]));
		j= 0;
		int k = 0;
		double a,b,c;
		gen_line(P[i],G[j],a,b,c);
		double d = 0;
		for (int k1 = 0; k1<cp.size(); ++k1){
			double d1 = fabs(a*cp[k1].first+b*cp[k1].second+c);
			if (d<d1){
				k =k1;
				d =d1;
			}
		}
		if (d>ans) ans = d;
		for(j=1;j<G.size(); ++j){
			gen_line(P[i],G[j],a,b,c);
			double d = fabs(a*cp[k].first+b*cp[k].second+c);
			double d1 = d;
			int k1 = k;
			int tt = 0;
			do{
				k = k1;
				d = d1;
				++k1;
				if (k1==cp.size()) k1 = 0;
				d1 = fabs(a*cp[k1].first+b*cp[k1].second+c);
				++tt;
			}while (d1-d>-1e-8&&tt<cp.size());
			if (d>ans) ans = d;
		}
	}
	return ans;
}

int main()
{
	ReadData("dist.dat");
	WriteAnswer(GetAnswer(),"dist.sol");
	return 0;
}