/* vc_cpp */

/* 
 * Problem  : 	DIST
 * Contest  : 	UOI-2006 (Dnepropetrovsk)
 * Type     : 	Solution
 * Date     : 	April 1, 2006
 * Author   : 	Vladimir Tkachuk
 * Language :	C++
 * Compiler :	VC 6.0
 * Algorithm:	O(N^3)
 */

#include <cmath>
#include <utility>
#include <vector>
#include <fstream>
#include <iomanip>
#include <string>
#include <iostream>
#include <algorithm>
#include <sstream>
using namespace std;
typedef pair<int,int> point;
#define sqr(a) ((a)*(a))
vector<point> P;
int N;
inline int operator &(point a, point b){
	return a.first*b.second-a.second*b.first;
}
inline int operator *(point a, point b){
	return a.first*b.first+a.second*b.second;
}
inline point operator - (point a, point b){
	return make_pair(a.first-b.first,a.second-b.second);
}
inline void gen_line(point A, point B, double &a, double &b, double &c){
	a = A.second-B.second;
	b = B.first-A.first;
	c = -a*A.first-b*A.second;
	double dd = sqrt(sqr(a)+sqr(b));
	a/=dd;
	b/=dd;
	c/=dd;
}

void ReadData(string filename){
	ifstream in(filename.c_str());
	in>>N;
	P.clear();
	for (int i =0; i<N; ++i){
		int x,y;
		in>>x>>y;
		P.push_back(make_pair(x,y));
	}
	in.close();
}
void WriteAnswer(double ans, string filename){
	ofstream out(filename.c_str());
	out<<setprecision(12)<<ans<<endl;
	out.close();
}

double GetAnswer1(){ // Simple with O(N^3)
	double ans = 0;
	for (int i = 0; i< N-1; ++i)
		for (int j = i+1; j<N; ++j){
			double a,b,c;
			gen_line(P[i],P[j],a,b,c);
			for (int k = 0; k<N; ++k)
				if (k!=i&&k!=j){
					double d = fabs(a*P[k].first+b*P[k].second+c);
					if (d>ans) ans = d;
				}
		}
	return ans;
}

int main()
{
	ReadData("dist.dat");
	WriteAnswer(GetAnswer1(),"dist.sol");
	return 0;
}