/* vc_cpp */

/* 
 * Problem  : 	DIST
 * Contest  : 	UOI-2006 (Dnepropetrovsk)
 * Type     : 	Solution
 * Date     : 	April 1, 2006
 * Author   : 	Vladimir Tkachuk
 * Language :	C++
 * Compiler :	VC 6.0
 * Algorithm:	Incorrect, O(N*M^2)
 */
#include <cmath>
#include <utility>
#include <vector>
#include <fstream>
#include <iomanip>
#include <string>
#include <iostream>
#include <algorithm>
#include <sstream>
using namespace std;
typedef pair<int,int> point;
#define sqr(a) ((a)*(a))
vector<point> P;
int N;
inline int operator &(point a, point b){
	return a.first*b.second-a.second*b.first;
}
inline int operator *(point a, point b){
	return a.first*b.first+a.second*b.second;
}
inline point operator - (point a, point b){
	return make_pair(a.first-b.first,a.second-b.second);
}
inline void gen_line(point A, point B, double &a, double &b, double &c){
	a = A.second-B.second;
	b = B.first-A.first;
	c = -a*A.first-b*A.second;
	double dd = sqrt(sqr(a)+sqr(b));
	a/=dd;
	b/=dd;
	c/=dd;
}
class PointComparer{
private:
	point t;
public:
	PointComparer(point t){
		this->t = t;
	}
	bool operator () (point& a, point& b){
		int s = (a-t)&(b-t);
		return (s<0||(s==0&&((a-t)*(b-a)<0)));
	}
};
void ReadData(string filename){
	ifstream in(filename.c_str());
	in>>N;
	P.clear();
	for (int i =0; i<N; ++i){
		int x,y;
		in>>x>>y;
		P.push_back(make_pair(x,y));
	}
	in.close();
}
void WriteAnswer(double ans, string filename){
	ofstream out(filename.c_str());
	out<<setprecision(12)<<ans<<endl;
	out.close();
}
vector<point> cp;
void BuildConvexHull(){
	point m = *min_element(P.begin(),P.end());
	sort(P.begin(),P.end(),PointComparer(m));
	cp.clear();
	int M =0;
	for(int i =0; i<N; ++i){
		while (cp.size()>1&&((cp[M-1]-cp[M-2])&(P[i]-cp[M-2]))>=0){
			--M;
			cp.pop_back();
		}
		cp.push_back(P[i]);
		++M;
	}
}

double GetAnswer2(){ // Incorrect with O(N*M^2)
	double ans = 0;
	BuildConvexHull();
	for (int i = 0; i< N; ++i)
		for (int j = 0; j<cp.size(); ++j){
			double a,b,c;
			gen_line(P[i],cp[j],a,b,c);
			for (int k = 0; k<cp.size(); ++k){
					double d = fabs(a*cp[k].first+b*cp[k].second+c);
					if (d>ans) ans = d;
				}
		}
	return ans;
}

int main()
{
	ReadData("dist.dat");
	WriteAnswer(GetAnswer2(),"dist.sol");
	return 0;
}