{ bp }


/* 
 * Problem  : 	EXAM
 * Contest  : 	UOI-2006 (Dnepropetrovsk)
 * Type     : 	Solution
 * Date     : 	March 24, 2006
 * Author   : 	Valery Istchenko
 * Language :	Pascal 
 * Compiler :	Borland Pascal
 * Algorithm:	Looks for the BIGGEST solution in lexical order
 */

const
	NMax=50;
	QUE_MAX=NMax;
var
	fin,fout:text;

	n,m:integer;
	i,j:integer;
	a,b:integer;

	g:array[1..NMax,1..NMax]of integer;

	down:array[1..NMax]of boolean;
	inpm:array[1..NMax]of boolean;

	back:array[1..NMax]of integer;

	count:integer;

	que:array[0..QUE_MAX]of integer;
	que_start,que_len:integer;

procedure greedy;
var
	i,j:integer;
begin
	for i:=n downto 1 do
		if (down[i]) and (not inpm[i]) then
			for j:=n downto 1 do
				if (not inpm[j]) and (g[i,j]=1) then
				 begin
				 	g[j,i]:=1;
				 	g[i,j]:=0;
				 	inpm[i]:=true;
				 	inpm[j]:=true;
				 	inc(count);
				 	break;
				 end;
end;

procedure QueClear;
begin
	que_start:=0;
	que_len:=0;
end;

procedure EnQue(a:integer);
begin
	if que_len=QUE_MAX then exit;
	que[(que_start+que_len)mod QUE_MAX]:=a;
	inc(que_len);
end;

function DeQue(var a:integer):boolean;
begin
	if que_len=0 then
	 begin
	 	DeQue:=false;
	 	exit;
	 end;
	a:=que[que_start];
	que_start:=(que_start+1)mod QUE_MAX;
        dec(que_len);
	DeQue:=true;
end;

function bsearch(k:integer):integer;
var
	i,j:integer;
begin
	QueClear;
	for j:=1 to n do
		back[j]:=0;
	EnQue(k);
	while DeQue(i) do
	 begin
	 	for j:=n downto 1  do
	 		if (back[j]=0) and (g[i,j]=1) then
	 		 begin
	 		 	back[j]:=i;
	 		 	if (not down[j]) and (not inpm[j]) then
	 		 	 begin
	 		 	 	bsearch:=j;
	 		 	 	exit;
	 		 	 end;
                                EnQue(j);
	 		 end;
	 end;
	bsearch:=-1;
end;

procedure pairmatch;
var
	i,t:integer;
begin
	for i:=n downto 1 do
		if (down[i]) and (not inpm[i]) then
		 begin
		 	t:=bsearch(i);
		 	if t>0 then
		 	 begin
		 	 	inpm[t]:=true;
		 	 	inpm[i]:=true;
		 	 	while back[t]<>0 do 
		 	 	 begin
		 	 	 	g[back[t],t]:=0;
		 	 	 	g[t,back[t]]:=1;
		 	 	 end;
		 	 end;
		 	break;
		 end;
end;

begin
	assign(fin,'exam.dat');
	reset(fin);

	readln(fin,n,m);
	for i:=1 to m do
	 begin
		readln(fin,a,b);
		g[b,a]:=1;
		down[b]:=true;
	 end;

	close(fin);

	greedy;

	pairmatch;

	assign(fout,'exam.sol');
	rewrite(fout);
	
	for i:=1 to n do
		if inpm[i] then 
		 begin	
			write(fout,i);
			j:=i;
			break;
		 end;
	for i:=j+1 to n do
		if inpm[i] then
		 	write(fout,' ',i);

	writeln(fout);

	close(fout);
end.
